mod Mtextm

rem 
  \para \bf  Turing Machines.  \end 

rem 
  \para \bf  Auxiliary functions and predicates.  \end 

appldisp/2 Tex_f2_tm_char_nef
  Infix(Arg(0),24,0,Subsup(Op('',Ent('NotEqual'),0),75,Op('*',0),None),Arg(1))

appldisp/2 Tex_f2_tm_pp_tuplef
  Prefix(100,2,Subsup(Id(0,'Tuple',0),75,Op('*',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex_f1_tm_nb_sz
  Fenced(Op(Ent('mid'),0),Arg(0),Op(Ent('mid'),0))

appldisp/2 Tex_f2_tm_nb_conc
  Infix(Arg(0),40,1,Op(Ent('sstarf'),0),Arg(1))

rem 
  \para \bf  Arithmetization of Turing machines.  \end 

rem 
  \para \it  Turing machines.  \end 

appldisp/0 Tex_f0_tm_a
  Id(1,'A',0)

appldisp/0 Tex_f0_tm_ar
  Id(1,'ARITY',0)

appldisp/1 Tex_f1_tm_cf
  Prefix(100,2,Fenced(Op(Ent('lang'),0),Id(1,'f',0),Op(Ent('rang'),0)),Arg(0))

rem 
  \para \it  Tape symbols.  \end 

appldisp/0 Tex_f0_tm_sb
  Id(2,'0',0)

appldisp/0 Tex_f0_tm_so
  Id(2,'1',0)

appldisp/0 Tex_p0_tm_ts
  Id(0,Ent('Sigma'),0)

appldisp/1 Tex_p1_tm_ts
  Infix(Arg(0),40,0,Op(Ent('isin'),0),Id(0,Ent('Sigma'),0))

appldisp/1 Tex_f1_tm_mkones
  Subsup(Id(2,'1',0),75,None,Arg(0))

rem 
  \para \it  Internal states.  \end 

appldisp/0 Tex_f0_tm_qb
  Id(1,'BEGIN',0)

appldisp/0 Tex_f0_tm_qe
  Id(1,'END',0)

appldisp/0 Tex_p0_tm_q
  Id(0,'Q',0)

appldisp/1 Tex_p1_tm_q
  Infix(Arg(0),40,0,Op(Ent('isin'),0),Id(0,'Q',0))

rem 
  \para \it  Movement.  \end 

appldisp/0 Tex_f0_tm_dh
  Op(Ent('dArr'),0)

appldisp/0 Tex_f0_tm_dl
  Op(Ent('lArr'),0)

appldisp/0 Tex_f0_tm_dr
  Op(Ent('rArr'),0)

appldisp/0 Tex_p0_tm_fd
  Id(0,Ent('Delta'),0)

appldisp/1 Tex_p1_tm_fd
  Infix(Arg(0),40,0,Op(Ent('isin'),0),Id(0,Ent('Delta'),0))

rem 
  \para \it  Input/output.  \end 

appldisp/2 Tex_f2_tm_enc1
  Std('Enc1',0)

appldisp/2 Tex_f2_tm_enc
  Std('Enc',0)

appldisp/1 Tex_f1_tm_dc1
  Std('Dc1',0)

appldisp/1 Tex_f1_tm_dc
  Std('Dc',0)

rem 
  \para \it  Computation.  \end 

appldisp/2 Tex_f2_tm_tf
  Std('m',0)

appldisp/1 Tex_f1_tm_run
  Std('M',0)

appldisp/1 Tex_f1_tm_urun
  Prefix(100,2,Subsup(Id(1,'M',0),75,None,Op('*',0)),Arg(0))

rem 
  \para \it  Debugging.  \end 

appldisp/2 Tex_f2_tm_brun
  Std('Brun',0)

appldisp/2 Tex_f2_tm_debug
  Std('Debug',0)

rem 
  \para \bf  Some Turing computable functions.  \end 

appldisp/1 Tex_f1_tm_rec_ss
  Std('S',0)

appldisp/1 Tex_f1_tm_rec_pred
  Infix(Arg(0),40,1,Op(Ent('minusd'),0),Num('1',0))

appldisp/2 Tex_f2_tm_rec_i_2_1
  Prefix(100,2,Subsup(Id(1,'I',0),100,Num('1',0),Num('2',0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/2 Tex_f2_tm_rec_i_2_2
  Prefix(100,2,Subsup(Id(1,'I',0),100,Num('2',0),Num('2',0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex_f1_tm_rec_twice
  Infix(Num('2',0),45,1,Op(Ent('sdot'),0),Arg(0))

